/**********************************************************************
 *
 * Filename: 	bsp.h
 * 
 * Description: Hardware and project-specific operating system details.
 *
 * Notes:       
 *
 * 
 * Copyright (c) 1998 by Michael Barr.  This software is placed into
 * the public domain and may be used for any purpose.  However, this
 * notice must not be changed or removed and no warranty is either
 * expressed or implied by its publication or distribution.
 **********************************************************************/

#ifndef _BSP_H
#define _BSP_H

#ifndef MASK_OUT_MODE
#define MASK_OUT_MODE 0xFFFFFFE0
#endif

#ifndef MODE_BITS
#define MODE_BITS 0x1F
#endif

#ifndef MASK_OUT_INT
#define MASK_OUT_INT 0xFFFFFF3F
#endif

#ifndef SR_I_FIELD
#define SR_I_FIELD       0xc0 // both interrupts
#endif

#ifndef SR_F_BIT
#define SR_F_BIT       0x40 // fast int
#endif

#ifndef SR_I_BIT
#define SR_I_BIT       0x80 // normal int 
#endif

#ifndef angel_SWIreason_EnterSVC
#define angel_SWIreason_EnterSVC 0x17
#endif

#ifndef angel_SWI_ARM
#define angel_SWI_ARM 0x123456
#endif

#ifndef USER_MODE
#define USER_MODE       0x10
#endif

#ifndef FIQ_MODE
#define FIQ_MODE        0x11
#endif

#ifndef IRQ_MODE
#define IRQ_MODE        0x12
#endif

#ifndef SV_MODE
#define SV_MODE         0x13
#endif

#ifndef ABORT_MODE
#define ABORT_MODE      0x17
#endif

#ifndef UNDEFINED_MODE
#define UNDEFINED_MODE  0x1b
#endif

#ifndef SYSTEM_MODE
#define SYSTEM_MODE     0x1F
#endif


struct Context {
  int pc;
  int lr;
  int sp;
  int cpsr; 
  int taskPointer;
};

#include "task.h"

unsigned int enterCS(void);
void exitCS(unsigned int);
void setModeMask(int mask);
void setIntMask(int mask);

//extern "C" 
//{
//  void  contextInit(Context *, void (*run)(Task *), Task *, int * pStackTop);
//  void  contextSwitch(Context * pOldContext, Context * pNewContext);
//  void  idle(void);
//};

//extern void  contextInit(Context *, void (*run)(Task *), Task *, int * pStackTop);
//extern void  contextSwitch(Context * pOldContext, Context * pNewContext);
extern void  idle(void);

#endif	/* _BSP_H */
