/**********************************************************************
 * File: memAllocator.cpp
 * Version: 0.1
 * Project: adeos
 * Created: 19 jan 2001
 * Last modified: 
 *
 * Comment:
 * The simulator does not know about the monitor program
 * "angel". "new int[stackSize];" does somewhere make a
 * call to the swi handler of angel. memAllocator will
 * get a decent amount of mem and allocate parts of it
 * to the callers of "memAllocator.new(int );"
 *
 *
 *
 * Author: Jens-Christian Lache
 * Fachbereich: TI3 Technische Informatik
 * Prof. Dr. Thomas Teufel
 * http://www.ti3.tu-harburg.de/deutsch/
 **********************************************************************/

#ifndef _MEMALLOCATOR
#define _MEMALLOCATOR

#define MEM_START (int *) 0x80
#define MEM_END (int *) 0xFFF
#define MAX_MEM_POINTER 256

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

typedef struct {
  int usedFlag;
  int * pStart;
  int * pEnd;
} fieldStruct;

class MemAllocator {
 public:
  MemAllocator(); 
  int * newMem(int memBytes);
  int deleteMem(int * pMemorie);
 private:
  fieldStruct mem[MAX_MEM_POINTER];
};

#endif // _MEMALLOCATOR
