/**********************************************************************
 * File: file.x
 * Version: 0.1
 * Project: 
 * Created:
 * Last modified:
 *
 * Comment:
 *
 *
 *
 * Author: Jens-Christian Lache
 * Fachbereich: TI3 Technische Informatik
 * Prof. Dr. Thomas Teufel
 * http://www.ti3.tu-harburg.de/deutsch/
 **********************************************************************/

#include "swi_handler.h"

int volatile angelJumpSWIopcode;

/**********************************************************************
 *
 * Function:    void swi_handler(int reason)
 *
 * Description: handle software trap
 *
 * Notes:       
 * 
 * Returns:     None defined.
 *
 **********************************************************************/

void swi_handler(int reason) {
#ifdef DEBUG
  int * memPointer;
  int cpsr;
  memPointer = (int *) 0x44;
#endif
  switch(reason) {
  case REASON_CHANGE_TO_SV :
    asm volatile ("mrs r0,cpsr": : :"r0");
    asm volatile ("orr r0, r0, #192": : :"r0");
    asm volatile ("msr cpsr, r0");
#ifdef DEBUG
    asm volatile ("mrs %0,cpsr":"=r" (cpsr));
    *memPointer = cpsr;
    // switch off LEDs
    memPointer = (int *) 0xFFFF0030;
    *memPointer = 0x16;
#endif    
  default :
    break;
  }
  asm volatile("movs    pc, lr");
}

/**********************************************************************
 *
 * Function:    void init_swi(void)
 *
 * Description: initialize swi_handler
 *
 * Notes:       
 * 
 * Returns:     None defined.
 *
 **********************************************************************/

void init_swi(void) {
  int swiArgument;
  int * memPointer;
  void  (* fctPointer) (int reason);
  int tmp;
  extern int volatile angelJumpSWIopcode;

  /***************************************************
   *  write the jump instruction
   *  ldr pc, [pc, #10] to 0x8
   *  this will load the value written
   *  at (pc + 0x18) into the pc.
   *  This value is the address of
   *  "void swi_handler(int reason)"
   *  
   **************************************************/

  // test
 //  memPointer = (int *) 0xFFFF0030;
//   *memPointer = 0x16;
//   memPointer = (int *) 0xFFFF0034;
//   *memPointer = 0x16;
  // test end

  // write the jump destination
  fctPointer = swi_handler;
  memPointer = TABLE_ENTRY_SWI_HANDLER_ADDRESS;
  *memPointer = (int) swi_handler;


  memPointer = JUMP_DESTINATION_SWI;
  // save instruction leading to angel
  angelJumpSWIopcode = *memPointer; 
  // write our own assembler instruction
  *memPointer= 0xe59ff010; 
  
}
